Loading...
Searching...
No Matches
caf::detail::stream_distribution_tree< Policy > Class Template Reference

A stream distribution tree consist of peers forming an acyclic graph. More...

`#include <stream_distribution_tree.hpp>`

Inheritance diagram for caf::detail::stream_distribution_tree< Policy >:

## Public Types

using | super = stream_manager
using | downstream_manager_type = typename Policy::downstream_manager_type
Public Types inherited from caf::stream_manager
using | inbound_paths_list = std::vector<inbound_path*>

## Public Member Functions

template<class... Ts>
| stream_distribution_tree (scheduled_actor *selfptr, Ts &&... xs)
Policy & | policy ()
const Policy & | policy () const
void | handle (inbound_path *path, downstream_msg::batch &x) override
void | handle (inbound_path *path, downstream_msg::close &x) override
void | handle (inbound_path *path, downstream_msg::forced_close &x) override
bool | handle (stream_slots slots, upstream_msg::ack_open &x) override
void | handle (stream_slots slots, upstream_msg::drop &x) override
void | handle (stream_slots slots, upstream_msg::forced_drop &x) override
bool | done () const override
| Returns whether the manager has reached the end and can be discarded safely.
bool | idle () const noexcept override
| Returns whether the manager cannot make any progress on its own at the moment.
downstream_manager_type & | out () override
| Returns the manager for downstream communication.
Public Member Functions inherited from caf::stream_manager
| stream_manager (scheduled_actor *selfptr, stream_priority prio=stream_priority::normal)
virtual void | handle (stream_slots slots, upstream_msg::ack_batch &x)
virtual void | stop (error reason=none)
| Closes all output and input paths and sends the final result to the client.
virtual void | shutdown ()
| Mark this stream as shutting down, only allowing flushing all related buffers of in- and outbound paths.
void | advance ()
| Tries to advance the stream by generating more credit or by sending batches.
virtual void | push ()
| Pushes new data to downstream actors by sending batches.
virtual bool | congested () const noexcept
| Returns true if the handler is not able to process any further batches since it is unable to make progress sending on its own.
virtual void | deliver_handshake (response_promise &rp, stream_slot slot, message handshake)
| Sends a handshake to dest.
virtual bool | generate_messages ()
| Tries to generate new messages for the stream.
const downstream_manager & | out () const
| Returns the manager for downstream communication.
virtual void | cycle_timeout (size_t cycle_nr)
| Advances time.
virtual void | register_input_path (inbound_path *x)
| Informs the manager that a new input path opens.
virtual void | deregister_input_path (inbound_path *x) noexcept
| Informs the manager that an input path closes.
virtual void | remove_input_path (stream_slot slot, error reason, bool silent)
| Removes an input path.
bool | running () const noexcept
| Returns whether this stream is neither shutting down nor has stopped.
bool | continuous () const noexcept
| Returns whether this stream remains open even if no in- or outbound paths exist.
void | continuous (bool x) noexcept
| Sets whether this stream remains open even if no in- or outbound paths exist.
const inbound_paths_list & | inbound_paths () const noexcept
| Returns the list of inbound paths.
inbound_path * | get_inbound_path (stream_slot x) const noexcept
| Returns the inbound paths at slot x.
bool | inbound_paths_idle () const noexcept
| Queries whether all inbound paths are up-to-date and have non-zero credit.
scheduled_actor * | self ()
| Returns the parent actor.
virtual int32_t | acquire_credit (inbound_path *path, int32_t desired)
| Acquires credit on an inbound path.
stream_slot | add_unchecked_inbound_path_impl (rtti_pair rtti)
| Adds the current sender as an inbound path.
Public Member Functions inherited from caf::ref_counted
| ref_counted (const ref_counted &)
ref_counted & | operator= (const ref_counted &)
void | ref () const noexcept
| Increases reference count by one.
void | deref () const noexcept
| Decreases reference count by one and calls request_deletion when it drops to zero.
bool | unique () const noexcept
| Queries whether there is exactly one reference.
size_t | get_reference_count () const noexcept

## Additional Inherited Members

Static Public Attributes inherited from caf::stream_manager
static constexpr int | is_continuous_flag = 0x0001
| Configures whether this stream shall remain open even if no in- or outbound paths exist.
static constexpr int | is_shutting_down_flag = 0x0002
| Denotes whether the stream is about to stop, only sending buffered elements.
static constexpr int | is_stopped_flag = 0x0004
| Denotes whether the manager has stopped.
Protected Member Functions inherited from caf::stream_manager
stream_slot | assign_next_slot ()
stream_slot | assign_next_pending_slot ()
virtual void | finalize (const error &reason)
virtual void | input_closed (error reason)
| Called when in().closed() changes to true.
virtual void | downstream_demand (outbound_path *ptr, long demand)
| Called whenever new credit becomes available.
virtual void | output_closed (error reason)
| Called when out().closed() changes to true.
Protected Attributes inherited from caf::stream_manager
scheduled_actor * | self_
| Points to the parent actor.
inbound_paths_list | inbound_paths_
| Stores non-owning pointers to all input paths.
long | pending_handshakes_
| Keeps track of pending handshakes.
stream_priority | priority_
| Configures the importance of outgoing traffic.
int | flags_
| Stores individual flags, for continuous streaming or when shutting down.
Protected Attributes inherited from caf::ref_counted
std::atomic< size_t > | rc_
Related Symbols inherited from caf::stream_manager
using | stream_manager_ptr = intrusive_ptr<stream_manager>
| A reference counting pointer to a stream_manager.
Related Symbols inherited from caf::ref_counted
void | intrusive_ptr_add_ref (const ref_counted *p)
void | intrusive_ptr_release (const ref_counted *p)

## Detailed Description

template<class Policy>
class caf::detail::stream_distribution_tree< Policy >

A stream distribution tree consist of peers forming an acyclic graph.

The user is responsible for making sure peers do not form a loop. Data is flooded along the tree. Each peer serves any number of subscribers. The policy of the tree enables subscriptions to different chunks of the whole stream (substreams).

The tree uses two CAF streams between each pair of peers for transmitting data. This automatically adds backpressure to the system, i.e., no peer can overwhelm others.

Policies need to provide the following member types and functions:

TODO
};

## Member Function Documentation

## done()

template<class Policy>

bool caf::detail::stream_distribution_tree< Policy >::done | ( |  | ) | const

override virtual

Returns whether the manager has reached the end and can be discarded safely.

Implements caf::stream_manager.

## handle() [1/6]

template<class Policy>

void caf::detail::stream_distribution_tree< Policy >::handle | ( | inbound_path * | path,
|  | downstream_msg::batch & | x )

override virtual

Reimplemented from caf::stream_manager.

## handle() [2/6]

template<class Policy>

void caf::detail::stream_distribution_tree< Policy >::handle | ( | inbound_path * | path,
|  | downstream_msg::close & | x )

override virtual

Reimplemented from caf::stream_manager.

## handle() [3/6]

template<class Policy>

void caf::detail::stream_distribution_tree< Policy >::handle | ( | inbound_path * | path,
|  | downstream_msg::forced_close & | x )

override virtual

Reimplemented from caf::stream_manager.

## handle() [4/6]

template<class Policy>

bool caf::detail::stream_distribution_tree< Policy >::handle | ( | stream_slots | slots,
|  | upstream_msg::ack_open & | x )

override virtual

Reimplemented from caf::stream_manager.

## handle() [5/6]

template<class Policy>

void caf::detail::stream_distribution_tree< Policy >::handle | ( | stream_slots | slots,
|  | upstream_msg::drop & | x )

override virtual

Reimplemented from caf::stream_manager.

## handle() [6/6]

template<class Policy>

void caf::detail::stream_distribution_tree< Policy >::handle | ( | stream_slots | slots,
|  | upstream_msg::forced_drop & | x )

override virtual

Reimplemented from caf::stream_manager.

## idle()

template<class Policy>

bool caf::detail::stream_distribution_tree< Policy >::idle | ( |  | ) | const

override virtual noexcept

Returns whether the manager cannot make any progress on its own at the moment.

For example, a source is idle if it has filled its output buffer and there isn't any credit left.

Implements caf::stream_manager.

## out()

template<class Policy>

downstream_manager_type & caf::detail::stream_distribution_tree< Policy >::out | ( |  | ) |

override virtual

Returns the manager for downstream communication.

Implements caf::stream_manager.

The documentation for this class was generated from the following file:

- /build/actor-framework-Z9pIPl/actor-framework-0.17.6/libcaf_core/caf/detail/stream_distribution_tree.hpp